// C Header File
// Created 03/03/2003; 11:21:18

//===================================================================================//

const char * options_titres[5] = 
{
	"level",
	"high",
	"next",
	"shadow",
	"link"
};

const char * options_modifs[5][10] = 
{
	{"00", "01", "02", "03", "04", "05", "06", "07", "08", "09"},
	{"00", "01", "02", "03", "04", "05"},
	{"off", "on"},
	{"off", "on"},
	{"off", "on"},
};

short options_dim[5] = {10, 6, 2, 2, 2};

//===================================================================================//

short X_CENTRE(short n)	// Centre les nombres et les lettres de 'MenuOptions'
{
	return (n < 2 ? 103: 99);
}

//===================================================================================//

void MenuFond(void)
{
	register short i;
	
	for(i = 0; i < 10; i ++)
	{
		Sprite16_GRIS_XOR(16*i, 0, brique_0, brique_1);
		Sprite16_GRIS_XOR(16*i, 84, brique_0, brique_1);
	}
	
	for(i = 1; i < 5; i ++)
	{
		Sprite16_GRIS_XOR(0, 16*i+2, brique_0, brique_1);
		Sprite16_GRIS_XOR(144, 16*i+2, brique_0, brique_1);
	}
	
	AfficheBmp(36, 1, tet, 6, GRIS_CLAIR);
	AfficheBmp(36, 1, tet, 6, GRIS_FONCE);
	AfficheBmp(36, 88, copy_0, 2, GRIS_CLAIR);
	AfficheBmp(36, 88, copy_1, 2, GRIS_FONCE);
}

//===================================================================================//

void MenuGeneral(void)
{
	Draw_SPECIAL(57, 22, "game", plan0, 4);
	Draw_SPECIAL(41, 34, "options", plan0, 4);
	Draw_SPECIAL(47, 46, "scores", plan0, 4);
	Draw_SPECIAL(52, 58, "about", plan0, 4);
	Draw_SPECIAL(57, 70, "exit", plan0, 4);
	Draw_SPECIAL(58, 23, "game", plan1, 4);
	Draw_SPECIAL(42, 35, "options", plan1, 4);
	Draw_SPECIAL(48, 47, "scores", plan1, 4);
	Draw_SPECIAL(53, 59, "about", plan1, 4);
	Draw_SPECIAL(58, 71, "exit", plan1, 4);
}

//===================================================================================//

void MenuOptions(void)
{
	register short i, y_options, n_options, flag_fondu;
	
	y_options = 32;
	n_options = 0;
	flag_fondu = 0;
	
	DebutMenu:
	
	if(flag_fondu)
	{
		DessineRectPlein(16, 16, 143, 83, 0, GRIS_CLAIR);
	  DessineRectPlein(16, 16, 143, 83, 0, GRIS_FONCE);
	}
	Draw_SPECIAL(41, 21, "options", plan0, 4);
	Draw_SPECIAL(42, 22, "options", plan1, 4);
	DessineRectPlein(16, 19, 143, 30, 2, GRIS_FONCE);
	DessineRectPlein(17, 32, 142, 80, 4, GRIS_CLAIR);
	
	for(i = 0; i < 5; i ++)
	{
		Draw_SPECIAL(20, 33+i*10, options_titres[i], plan0, 0);
		Draw_SPECIAL(21, 34+i*10, options_titres[i], plan1, 0);
		Sprite16_GRIS_XOR(90, 32+i*10, gauche2_0, gauche2_1);
		Sprite16_GRIS_XOR(133, 32+i*10, droite2_0, droite2_1);
		if(i != n_options)
		 Draw_SPECIAL(X_CENTRE(i), 33+i*10, options_modifs[i][options[i]], plan0, 0);
	}

	DessineRectPlein(88, y_options, 140, y_options+8, 2, GRIS_CLAIR);
	DessineRectPlein(88, y_options, 140, y_options+8, 2, GRIS_FONCE);
	Draw_SPECIAL(X_CENTRE(n_options), y_options+1, options_modifs[n_options][options[n_options]], plan1, 0);
	Draw_SPECIAL(X_CENTRE(n_options)+1, y_options+2, options_modifs[n_options][options[n_options]], plan0, 0);
	
	if(!flag_fondu)
	{
		FonduHaut();
	}
	flag_fondu = 1;
	
	do
	{
		PressionTouche(NE_FAIT_RIEN);
		if(BAS || HAUT)
		{
			DessineRectPlein(88, y_options, 140, y_options+8, 2, GRIS_FONCE);
			DessineRectPlein(88, y_options, 140, y_options+8, 2, GRIS_CLAIR);
			
			Draw_SPECIAL(X_CENTRE(n_options), y_options+1, options_modifs[n_options][options[n_options]], plan1, 0);
			Draw_SPECIAL(X_CENTRE(n_options)+1, y_options+2, options_modifs[n_options][options[n_options]], plan0, 0);
			Draw_SPECIAL(X_CENTRE(n_options), y_options+1, options_modifs[n_options][options[n_options]], plan0, 0);

			if(BAS)
			{
				if(y_options == 72)
				{
	  			n_options = 0;
	  			y_options = 32;
	  			goto DebutMenu;
				}
				y_options += 10;
				n_options ++;
			}
			else
			{
				if(y_options == 32)
				{
	  			n_options = 4;
	  			y_options = 72;
	  			goto DebutMenu;
				}
				y_options -= 10;
				n_options --;
			}	
			
			DessineRectPlein(88, y_options, 140, y_options+8, 2, GRIS_CLAIR);
	    DessineRectPlein(88, y_options, 140, y_options+8, 2, GRIS_FONCE);
	    
			Draw_SPECIAL(X_CENTRE(n_options), y_options+1, options_modifs[n_options][options[n_options]], plan0, 0);
			Draw_SPECIAL(X_CENTRE(n_options), y_options+1, options_modifs[n_options][options[n_options]], plan1, 0);
			Draw_SPECIAL(X_CENTRE(n_options)+1, y_options+2, options_modifs[n_options][options[n_options]], plan0, 0);
		}
		
		if(GAUCHE || DROITE)
		{			
			Draw_SPECIAL(X_CENTRE(n_options), y_options+1, options_modifs[n_options][options[n_options]], plan1, 0);
			Draw_SPECIAL(X_CENTRE(n_options)+1, y_options+2, options_modifs[n_options][options[n_options]], plan0, 0);
			if(GAUCHE)
			{
				options[n_options] = (options[n_options] == 0 ? options_dim[n_options]-1: options[n_options]-1);
			}
			else
			{
				options[n_options] ++;
				options[n_options] %= options_dim[n_options];
			}
			Draw_SPECIAL(X_CENTRE(n_options), y_options+1, options_modifs[n_options][options[n_options]], plan1, 0);
			Draw_SPECIAL(X_CENTRE(n_options)+1, y_options+2, options_modifs[n_options][options[n_options]], plan0, 0);				
		}
		
	}while(!ESCAPE && !ENTER && !SECOND);
}

//===================================================================================//

void MenuScores(void)
{
	register short i;
	
	Draw_SPECIAL(47, 21, "scores", plan0, 4);
	Draw_SPECIAL(48, 22, "scores", plan1, 4);
	DessineRectPlein(16, 19, 143, 30, 2, GRIS_FONCE);
	DessineRectPlein(17, 32, 142, 80, 4, GRIS_CLAIR);
	
	for(i = 0; i < 5; i ++)
	{
		AfficheChaine(20, 33+10*i, hscore[i].nom, 2, GRIS_FONCE, NORMAL);
		AfficheNb(104, 33+10*i, hscore[i].score, 6, 2, GRIS_FONCE, NORMAL);
	}
	
	FonduHaut();
}

//===================================================================================//

void MenuAbout(void)
{
	Draw_SPECIAL(52, 21, "about", plan0, 4);
	Draw_SPECIAL(53, 22, "about", plan1, 4);
	DessineRectPlein(16, 19, 143, 30, 2, GRIS_FONCE);
	DessineRectPlein(17, 32, 142, 80, 4, GRIS_CLAIR);
	AfficheChaine(22, 34, "Compiled with TIGCC", 4, GRIS_FONCE, NORMAL);
	AfficheChaine(50, 44, "Date: "DATE, 4, 1, GRIS_CLAIR);
	AfficheChaine(31, 51, "version "VERSION, 2, GRIS_CLAIR, GROS);
	AfficheChaine(32, 52, "version "VERSION, 2, GRIS_FONCE, GROS);
	AfficheChaine(58, 64, "E-mail:", 4, GRIS_FONCE, NORMAL);
	DessineLigne(59, 72, 97, 72, 2, GRIS_CLAIR);
	DessineLigne(59, 72, 97, 72, 2, GRIS_FONCE);
	AfficheChaine(25, 75, "olivier_givaudan@hotmail.com", 4, GRIS_FONCE,PETIT);
	FonduHaut();
	EnterEsc();
}

//===================================================================================//

void HighScore(unsigned long score)
{
	unsigned char lcd[2*LCD_SIZE];
	unsigned char nom[] = "            ";
	register short key, dim, i;
	
	dim = 0;
	
	for(i = 4; hscore[i-1].score < score && (long)i; i --)
	{
		memcpy(&hscore[i], &hscore[i-1], sizeof(HIGH_SCORES)); 
	}
    
	hscore[i].score = score;
	
	RestaureInterruptions();
	GrayOn();
	FonduBas(EFFACE_DEUX_PLANS);
	if(!TI89)
	{
		FondEcran();
		EffacePlans();
	} 
	MenuFond();
	MenuScores();
	DessineRectPlein(0, 87, 159, 97, 4, GRIS_CLAIR);
	DessineRectPlein(0, 87, 159, 97, 4, GRIS_FONCE);
	DessineRectPlein(0, 87, 159, 97, 0, GRIS_FONCE);
	DessineRectPlein(0, 87, 159, 97, 4, GRIS_CLAIR);
	AfficheChaine(23, 87, "New Highscore!", 2, GRIS_CLAIR, GROS);
	AfficheChaine(23 ,88, "New Highscore!", 2, GRIS_FONCE, GROS);
	Sprite8_GRIS_XOR(17, 33+i*10, droite1_0, droite1_1);
	GKeyFlush();
	
	do
	{
		
		AfficheChaine(20, 33+i*10, nom, 4, GRIS_FONCE, NORMAL);
		key = ngetchx();
		
		if(key >= 18 && key <= 255 && dim < 12)
		{
			nom[dim ++] = key;
		}
		else if(key == KEY_BACKSPACE && dim > 0)
		{
			nom[-- dim] = ' ';
		}
		else if(key == KEY_CLEAR)
		{
			memset(nom, ' ', 12);
			dim = 0;
		}
		else if(key == KEY_APPS)
		{
			off();
		}
		 
	}while(key != KEY_ENTER);
	
	strcpy(hscore[i].nom, nom);
	Sprite8_GRIS_XOR(17, 33+i*10, droite1_0, droite1_1);
	SauveImg(lcd);
	GrayOff();
	RedirigeInterruptions();
	RestaureImg(lcd);
	DessineRectPlein(0, 83, 159, 99, 0, GRIS_CLAIR);
	DessineRectPlein(0, 83, 159, 99, 0, GRIS_FONCE);
	
	for(i = 0; i < 10; i ++)
	{
		Sprite16_GRIS_XOR(16*i, 84, brique_0, brique_1);
	}
	
	AfficheBmp(36, 88, copy_0, 2, GRIS_CLAIR);
	AfficheBmp(36, 88, copy_1, 2, GRIS_FONCE);
	PressionTouche(TESTE_ET_SORT);
	EnterEsc();
}

//===================================================================================//