// C Header File
// Created 28/02/2003; 10:56:52

//===================================================================================//

short TestCollision(short x_piece, short y_piece, short position, short piece)
{
	register short i;
	
	for(i = 0; i < 16; i ++)
	{
		if((EXT_GETPIX(plan0, ADAPT_x+x_piece+8*(i%4), ADAPT_y+y_piece+6*(i/4)-(y_piece+6*(i/4) >= 0? 0: y_piece)) || EXT_GETPIX(plan1, ADAPT_x+x_piece+8*(i%4), ADAPT_y+y_piece+6*(i/4)-(y_piece+6*(i/4) >= 0? 0: y_piece))) && matrice_motifs[piece][position][i] != 0)
		{
			return 1;
		}
	}
	
	return 0;
}

//===================================================================================//

short TestHauteur(short y_piece)	// Sert en link pour afficher la barre de hauteur
{
	register short i, j;
	
  for(i = y_piece; i <= y_piece+18; i += 6)
	{
		for(j = 16; j <= 88; j += 8)
		{
			if(EXT_GETPIX(plan1, j+ADAPT_x, i+ADAPT_y))
			{
				goto Fin;
			}
		}
	}
	
	Fin:
	return i;
}

//===================================================================================//

short TestLignes(short y_piece)	// Pour dterminer si on peut effacer des lignes
{
	unsigned char * buffer_0 = NULL;
	unsigned char * buffer_1 = NULL;
	short liste_y[4] = {};	// Liste des ordonnes des lignes entirement remplies
	register short i, j, flag, nbre_lignes;
	
	nbre_lignes = 0;
	
	for(i = y_piece; i <= y_piece+18; i += 6)				// Dtermine le nombre de lignes 
	{																								// qui sont entirement remplies
		flag = 1;																			// pour ensuite les faire clignoter
		for(j = 16; j <= 88; j += 8)									// pendant quelques secondes
		{																							// puis enfin les effacer
			if(!EXT_GETPIX(plan1, j+ADAPT_x, i+ADAPT_y) || i >= 96)
			{
				flag = 0;
				break;
			}
		}
		if(flag)
		{
			liste_y[nbre_lignes++] = i; 
		}
	}
	
	if(nbre_lignes == 0)
	{
		return 0;
	}
	
	if(nbre_lignes == 4)
	{
		buffer_0 = malloc(800);
		buffer_1 = malloc(800);
		SCR_RECT my_screen = {{ADAPT_x+112, ADAPT_y, ADAPT_x+159, ADAPT_y+99}};
		GraySetAMSPlane(GRIS_CLAIR);
  	BitmapGet(&my_screen, buffer_0);
  	GraySetAMSPlane(GRIS_FONCE);
  	BitmapGet(&my_screen, buffer_1);
  	AfficheBmp(112, 0, buffer_0, 2, GRIS_CLAIR);
  	AfficheBmp(112, 0, buffer_1, 2, GRIS_FONCE);
  	DessineRectPlein(112, 0, 159, 99, 2, GRIS_CLAIR);
  	AfficheBmp(122, 0, tet_zarb, 2, GRIS_CLAIR);	// Affiche le 'Tetrics' verticalement sur le ct droit
  	AfficheBmp(123, 1, tet_zarb, 2, GRIS_FONCE);	// de l'cran si on a fait un ttris
	}
	
	for(i = 0; i <= 4; i ++)													// Ceci fait clignoter les lignes
	{																								// entirement remplies 
		for(j = 0; j < nbre_lignes; j ++)							
		{
			DessineRectPlein(16, liste_y[j], 96, liste_y[j]+5, 2, GRIS_CLAIR);
			DessineRectPlein(16, liste_y[j], 96, liste_y[j]+5, 2, GRIS_FONCE);
		}
		Attend(18);
	}
	
	for(i = 0; i < nbre_lignes; i ++)									// Ceci efface les lignes 
	{																									// entirement remplies
		for(j = liste_y[i]-1+ADAPT_y; j >= 0; j --)			// et abaisse le niveau du jeu
		{
		 memcpy(plan0+2+ADAPT_x/8+(j+6)*30, plan0+2+ADAPT_x/8+j*30, 10);
		 memcpy(plan1+2+ADAPT_x/8+(j+6)*30, plan1+2+ADAPT_x/8+j*30, 10);
		}
	}  
  
  if(nbre_lignes == 4)
  {
  	DessineRectPlein(112, 0, 159, 99, 0, GRIS_CLAIR);
  	DessineRectPlein(112, 0, 159, 99, 0, GRIS_FONCE);
  	AfficheBmp(112, 0, buffer_0, 4, GRIS_CLAIR);
  	AfficheBmp(112, 0, buffer_1, 4, GRIS_FONCE);
  	free(buffer_0);
  	free(buffer_1);
  }
  
  DessineRectPlein(16, (TI89 ? 0: -12), 95, (TI89 ? 5: -7), 0, GRIS_CLAIR);
	DessineRectPlein(16, (TI89 ? 0: -12), 95, (TI89 ? 5: -7), 0, GRIS_FONCE);
   
  return nbre_lignes;
}

//===================================================================================//

void DessineShadow(short * x, short * y, short piece, short position)
{
	register short i;
	if(!shadow) return;
	
	while(!TestCollision(*x, *y+6, position, piece))
	{
		*y += 6;
	}
	
	
	for(i = 0; i < 16; i ++)
	{
		if(matrice_motifs[piece][position][i])
		{
			Sprite16_GRIS_AND(*x+8*(i%4)-1, *y+6*(i/4)-1, mask_motifs, mask_motifs);
		}
	}
	
	for(i = 0; i < 16; i ++)
	{
		if(matrice_motifs[piece][position][i])
		{
			Sprite8_GRIS_OR(*x+8*(i%4), *y+6*(i/4), motifs_0[0], motifs_1[2]);
		}
	}
}

//===================================================================================//